      subroutine com_int(lop)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iop,iop0,id,ib,isbkx,iebkx,ix,iz,
     &           jb,i0,k0,i1,k1,iy,ix1,ix2,lop(*),
     &           i5
      integer,allocatable :: itmp0(:),itmp1(:),jop(:,:),
     &                       ckbk1(:),ckbk2(:),ckbk3(:),ckbk4(:)
      real(8),allocatable :: temp(:,:)

      allocate(jop(nit,5),th(1)%np(nit,ista_int:iend_int))
      jop=0; th(1)%np=0
      do iop=ista_int,iend_int
        do iy=1,5 !kinds of matrix-matrix product
          do ix=1,nit !kinds of interaction
            if(lop(iop).eq.iy+ishft(ix,8)) then
              th(1)%fst(iop)=1
              if(jop(ix,iy).eq.0) then
                jop(ix,iy)=iop
              end if
              th(1)%np(ix,jop(ix,iy))=th(1)%np(ix,jop(ix,iy))+1
            end if
          enddo
        enddo
      enddo

c      do iop=ista_int,iend_int
c        write(6,*) iop,th(1)%np(iop),iand(255,lop(iop)),
c     &             ishft(lop(iop),-8)
c      enddo

      i5=0
      do ix=1,nit
        if(jop(ix,5).ne.0) then
          i5=ix
          exit
        end if
      enddo

      if(i5.ne.0) then
        do iy=1,4
          do ix=1,nit
            allocate(pop(iy,jop(ix,5))%ns(nfr,nit,isbk0:iebk0),
     &               pop(iy,jop(ix,5))%st(nit))
            pop(iy,jop(ix,5))%ns=0
          enddo
        enddo

        do ix=1,nit
          do iy=1,4
            if(jop(ix,5).eq.0) cycle
            allocate(pop(iy,jop(ix,5))%st(ix)%fs(nfr),
     &               pop(iy,jop(ix,5))%st(ix)%vo(nfr),
     &               pop(iy,jop(ix,5))%st(ix)%jbk(nbk))
            pop(iy,jop(ix,5))%st(ix)%fs=kop(mod(iy+1,2)+1,jop(ix,5))%fs
            pop(iy,jop(ix,5))%st(ix)%vo=kop(mod(iy+1,2)+1,jop(ix,5))%vo
            pop(iy,jop(ix,5))%st(ix)%jbk
     &                                =kop(mod(iy+1,2)+1,jop(ix,5))%jbk
          enddo

          do ib=isbk0,iebk0
            jb=kop(1,jop(ix,5))%jbk(ib)
            if(jb.eq.0) cycle
            do i0=1,nfr
              do k0=1,nfr
                i1=kop(1,jop(ix,5))%io(i0)
                k1=kop(2,jop(ix,5))%io(k0)
                if(i1*k1.eq.0) cycle
                if(bk(ib,1)%sizex(i1)*bk(ib,2)%sizex(k1)
     &            *bk(jb,1)%sizex(i0)*bk(jb,2)%sizex(k0).eq.0) cycle

                pop(1,jop(ix,5))%ns(i0,ix,ib)
     &            =bk(jb,1)%sizex(i0)*th(1)%np(ix,jop(ix,5))
                pop(2,jop(ix,5))%ns(k0,ix,ib)
     &            =bk(ib,2)%sizex(k1)*th(1)%np(ix,jop(ix,5))

              enddo
            enddo
          enddo

          do ib=isbk0,iebk0
            jb=kop(2,jop(ix,5))%jbk(ib)
            if(jb.eq.0) cycle
            do i0=1,nfr
              do k0=1,nfr
                i1=kop(1,jop(ix,5))%io(i0)
                k1=kop(2,jop(ix,5))%io(k0)
                if(i1*k1.eq.0) cycle
                if(bk(ib,1)%sizex(i0)*bk(ib,2)%sizex(k0)
     &            *bk(jb,1)%sizex(i1)*bk(jb,2)%sizex(k1).eq.0) cycle

                pop(3,jop(ix,5))%ns(i0,ix,ib)
     &            =bk(jb,1)%sizex(i1)*th(1)%np(ix,jop(ix,5))
                pop(4,jop(ix,5))%ns(k0,ix,ib)
     &            =bk(ib,2)%sizex(k0)*th(1)%np(ix,jop(ix,5))

              enddo
            enddo
          enddo

        enddo

c        do ix=1,nit !kinds of interaction
c          if(jop(ix,5).ne.0) then
c            iy=th(1)%np(ix,jop(ix,5))
c            th(1)%np(ix,jop(ix,5))=0
c            th(1)%np(ix,jop(i5,5))=th(1)%np(ix,jop(i5,5))+iy
c          end if
c        enddo

c        do iop=ista_int,iend_int
c          write(6,*) iop,th(1)%np(iop)
c        enddo
c        do ib=isbk0,iebk0
c          do ix=1,nit
c            write(6,*) ib,pop(1,jop(i5,5))%ns(:,ix,ib)
c          enddo
c        enddo
c        call mpi_finalize(ierr); stop
      end if


      allocate(ckbk1(block(1,nse(1))%nbk),ckbk2(block(2,nse(2))%nbk))
      allocate(ckbk3(block(1,nse(1))%nbk),ckbk4(block(2,nse(2))%nbk))
      do ix=1,nit
        if(jop(ix,5).eq.0) cycle
        ckbk1=0; ckbk2=0
        ckbk3=0; ckbk4=0
        allocate(pop(1,jop(ix,5))%bt(block(1,nse(1))%nbk))
        allocate(pop(2,jop(ix,5))%st(ix)%bt(block(2,nse(2))%nbk))
        allocate(pop(3,jop(ix,5))%bt(block(1,nse(1))%nbk))
        allocate(pop(4,jop(ix,5))%st(ix)%bt(block(2,nse(2))%nbk))

        do ib=isbk0,iebk0
          jb=kop(1,jop(ix,5))%jbk(ib)
          if(jb.eq.0) cycle
          do i0=1,nfr
            do k0=1,nfr
              i1=kop(1,jop(ix,5))%io(i0)
              k1=kop(2,jop(ix,5))%io(k0)
              if(i1*k1.eq.0) cycle
              if(bk(ib,1)%sizex(i1)*bk(ib,2)%sizex(k1)
     &          *bk(jb,1)%sizex(i0)*bk(jb,2)%sizex(k0).eq.0) cycle

              if(ckbk1(bk(ib,1)%ap(ad(i1,k1))%nse(1)).eq.0) then
                if(.not.allocated(pop(1,jop(ix,5))%bt(bk(ib,1)
     &                            %ap(ad(i1,k1))%nse(1))%op)) then
                  allocate(pop(1,jop(ix,5))%bt(bk(ib,1)
     &                       %ap(ad(i1,k1))%nse(1))
     &                       %op(pop(1,jop(ix,5))%ns(i0,ix,ib),
     &                           bk(ib,1)%sizex(i1)))
                end if

                iy=0
                iz=sum(pop(1,jop(ix,5))%ns(i0,1:(ix-1),ib))
                do iop=ista_int,iend_int
                  if(lop(iop).eq.5+ishft(ix,8)) then
                    do ix2=1,bk(ib,1)%sizex(i1)
                      do ix1=1,bk(jb,1)%sizex(i0)
                        pop(1,jop(ix,5))%bt(bk(ib,1)
     &                    %ap(ad(i1,k1))%nse(1))
     &                      %op(ix1+bk(jb,1)%sizex(i0)*iy,ix2)
     &                   =kop(1,iop)%bt(bk(ib,1)
     &                     %ap(ad(i1,k1))%nse(1))%op(ix1,ix2)
                      enddo
                    enddo
c                    deallocate(kop(1,iop)%bt(bk(ib,1)
c     &                         %ap(ad(i1,k1))%nse(1))%op)
                    iy=iy+1
                  end if
                enddo

                ckbk1(bk(ib,1)%ap(ad(i1,k1))%nse(1))=1

              end if

              if(ckbk2(bk(ib,1)%ap(ad(i1,k1))%nse(2)).eq.0) then
                if(.not.allocated(pop(2,jop(ix,5))%st(ix)%bt(bk(ib,1)
     &                            %ap(ad(i1,k1))%nse(2))%op)) then
                  allocate(pop(2,jop(ix,5))%st(ix)%bt(bk(ib,1)
     &                       %ap(ad(i1,k1))%nse(2))
     &                       %op(bk(jb,2)%sizex(k0),
     &                           pop(2,jop(ix,5))%ns(k0,ix,ib)))
                end if

                iy=0
                do iop=ista_int,iend_int
                  if(lop(iop).eq.5+ishft(ix,8)) then
                    do ix2=1,bk(ib,2)%sizex(k1)
                      do ix1=1,bk(jb,2)%sizex(k0)
                        pop(2,jop(ix,5))%st(ix)%bt(bk(ib,1)
     &                    %ap(ad(i1,k1))%nse(2))
     &                      %op(ix1,ix2+bk(ib,2)%sizex(k1)*iy)
     &                    =kop(2,iop)%bt(bk(ib,1)
     &                      %ap(ad(i1,k1))%nse(2))%op(ix1,ix2)
                      enddo
                    enddo
c                    deallocate(kop(2,iop)%bt(bk(ib,1)
c     &                         %ap(ad(i1,k1))%nse(2))%op)
                    iy=iy+1
                  end if
                enddo

                ckbk2(bk(ib,1)%ap(ad(i1,k1))%nse(2))=1

              end if

            enddo
          enddo
        enddo

        do ib=isbk0,iebk0
          jb=kop(2,jop(ix,5))%jbk(ib)
          if(jb.eq.0) cycle
          do i0=1,nfr
            do k0=1,nfr
              i1=kop(1,jop(ix,5))%io(i0)
              k1=kop(2,jop(ix,5))%io(k0)
              if(i1*k1.eq.0) cycle
              if(bk(ib,1)%sizex(i0)*bk(ib,2)%sizex(k0)
     &          *bk(jb,1)%sizex(i1)*bk(jb,2)%sizex(k1).eq.0) cycle

              if(ckbk3(bk(jb,1)%ap(ad(i1,k1))%nse(1)).eq.0) then
                if(.not.allocated(pop(3,jop(ix,5))%bt(bk(ib,1)
     &                            %ap(ad(i1,k1))%nse(1))%op)) then
                  allocate(pop(3,jop(ix,5))%bt(bk(ib,1)
     &                       %ap(ad(i1,k1))%nse(1))
     &                       %op(bk(ib,1)%sizex(i0),
     &                           pop(3,jop(ix,5))%ns(i0,ix,ib)))
                end if

                iy=0
                iz=sum(pop(3,jop(ix,5))%ns(i0,1:(ix-1),ib))
                do iop=ista_int,iend_int
                  if(lop(iop).eq.5+ishft(ix,8)) then
                    do ix2=1,bk(jb,1)%sizex(i1)
                      do ix1=1,bk(ib,1)%sizex(i0)
                        pop(3,jop(ix,5))%bt(bk(ib,1)
     &                    %ap(ad(i1,k1))%nse(1))
     &                      %op(ix1,ix2+bk(jb,1)%sizex(i1)*iy)
     &                    =kop(1,iop)%bt(bk(jb,1)
     &                      %ap(ad(i1,k1))%nse(1))%op(ix1,ix2)
                      enddo
                    enddo
c                    deallocate(kop(1,iop)%bt(bk(ib,1)
c     &                         %ap(ad(i1,k1))%nse(1))%op)
                    iy=iy+1
                  end if
                enddo

                ckbk3(bk(jb,1)%ap(ad(i1,k1))%nse(1))=1

              end if

              if(ckbk4(bk(jb,1)%ap(ad(i1,k1))%nse(2)).eq.0) then
                if(.not.allocated(pop(4,jop(ix,5))%st(ix)%bt(bk(jb,1)
     &                            %ap(ad(i1,k1))%nse(2))%op)) then
                  allocate(pop(4,jop(ix,5))%st(ix)%bt(bk(jb,1)
     &                       %ap(ad(i1,k1))%nse(2))
     &                       %op(pop(4,jop(ix,5))%ns(k0,ix,ib),
     &                           bk(jb,2)%sizex(k1)))
                end if

                iy=0
                do iop=ista_int,iend_int
                  if(lop(iop).eq.5+ishft(ix,8)) then
                    do ix2=1,bk(jb,2)%sizex(k1)
                      do ix1=1,bk(ib,2)%sizex(k0)
                        pop(4,jop(ix,5))%st(ix)%bt(bk(jb,1)
     &                    %ap(ad(i1,k1))%nse(2))
     &                      %op(ix1+bk(ib,2)%sizex(k0)*iy,ix2)
     &                    =kop(2,iop)%bt(bk(jb,1)
     &                      %ap(ad(i1,k1))%nse(2))%op(ix1,ix2)
                      enddo
                    enddo
c                    deallocate(kop(2,iop)%bt(bk(ib,1)
c     &                         %ap(ad(i1,k1))%nse(2))%op)
                    iy=iy+1
                  end if
                enddo

                ckbk4(bk(jb,1)%ap(ad(i1,k1))%nse(2))=1

              end if

            enddo
          enddo
        enddo
      enddo

      deallocate(jop,ckbk1,ckbk2,ckbk3,ckbk4)

      return
      end
