      subroutine energy(vi,a)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      real(8) :: a
      integer(1) :: id_timex
      integer(8) :: imem
      type(avec) :: vi(isbk1:iebk1)

      if(.not.allocated(time_test)) then
        allocate(time_test(0:26))
        time_test=0.d0
        id_timex=1
      else
        id_timex=0
      end if

      allocate(v2(isbk0:iebk0,2))
      call lz_acv(v2(isbk0:iebk0,1),isbk0,iebk0,0,imem)
      call lz_acv(v2(isbk0:iebk0,2),isbk0,iebk0,1,imem)

      if(iebk0.ge.isbk0) then
        call lz_init(vi(isbk1:iebk1),isbk1,iebk1,
     &               v2(isbk0:iebk0,1),isbk0,iebk0)
      end if

      call matrix_vec(1,v2(:,1),v2(:,2),one)

      call ipv(v2(isbk1:iebk1,1),v2(isbk1:iebk1,2),isbk1,iebk1,a)

      deallocate(v2)

      if(id_timex.eq.1) then
        deallocate(time_test)
      end if

      return
      end
