      subroutine fermi_sign(ise0,iop0,it)
      use mod_dmrg
      implicit none
      integer :: ise0,iop0,it,ix

      allocate(kop(ise0,iop0)%fs(nfrx(ise0)))

      if(kud(it).eq.0.or.fsi(it).ge.0.d0.or.
     &    (ise0.eq.1.and.nas.eq.0).or.(ise0.eq.2.and.nae.eq.0)) then
!$OMP PARALLEL WORKSHARE
        kop(ise0,iop0)%fs=one
!$OMP END PARALLEL WORKSHARE
      else
        if(iftp.eq.1) then
!$OMP PARALLEL DO
          do ix=1,nfrx(ise0)
#ifdef cmplx_v
            kop(ise0,iop0)%fs(ix)=cmplx(fsi(it)**iud(ix,kud(it)),
     &                                  0.d0,kind=8)
#else
            kop(ise0,iop0)%fs(ix)=fsi(it)**iud(ix,kud(it))
#endif
          enddo
        elseif(iftp.eq.2) then
!$OMP PARALLEL DO
          do ix=1,nfrx(ise0)
#ifdef cmplx_v
            kop(ise0,iop0)%fs(ix)=cmplx(fsi(it)**(iud(ix,1)+iud(ix,2)),
     &                                  0.d0,kind=8)
#else
            kop(ise0,iop0)%fs(ix)=fsi(it)**(iud(ix,1)+iud(ix,2))
#endif
          enddo
        else
!$OMP PARALLEL WORKSHARE
          kop(ise0,iop0)%fs=one
!$OMP END PARALLEL WORKSHARE
        end if
      end if

      return
      end
