      subroutine lz_init(vin,ista_bk0,iend_bk0,vout,ista_bk,iend_bk)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ista_bk0,iend_bk0,ista_bk,iend_bk,ib,i,k,ix1,ix2,ix,
     &           nfa,ih
      type(avec) :: vin(ista_bk0:iend_bk0),vout(ista_bk:iend_bk)

      ih=1

      nfa=nfrx(1)*nfrx(2)
      if(np_int.gt.1) then
        do ix=0,nfa*(iend_bk-ista_bk+1)-1
          ib=ix/nfa+ista_bk
          i=mod(ix/nfrx(2),nfrx(1))+1
          k=mod(ix,nfrx(2))+1
          if(myid_int.eq.kid1(ib)) then
!$OMP PARALLEL DO
            do ix2=bk(ib,2,ih)%ivs(k),bk(ib,2,ih)%ive(k)
              do ix1=bk(ib,1,ih)%ivs(i),bk(ib,1,ih)%ive(i)
                vout(ib)%ap(ad(i,k))%b(ix1,ix2)
     &            =vin(ib)%ap(ad(i,k))%b(ix1,ix2)
              enddo
            enddo
          end if
          call mpi_bcast(vout(ib)%ap(ad(i,k))
     &                     %b(:,bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)),
     &                   (bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &                  *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1),
     &                    mpi_kv,kid1(ib),newcomm_int,ierr)
        enddo
      else
c!$OMP PARALLEL DO PRIVATE(ib,i,k)
        do ix=0,nfa*(iend_bk-ista_bk+1)-1
          ib=ix/nfa+ista_bk
          i=mod(ix/nfrx(2),nfrx(1))+1
          k=mod(ix,nfrx(2))+1
          do ix2=bk(ib,2,ih)%ivs(k),bk(ib,2,ih)%ive(k)
            do ix1=bk(ib,1,ih)%ivs(i),bk(ib,1,ih)%ive(i)
              vout(ib)%ap(ad(i,k))%b(ix1,ix2)
     &          =vin(ib)%ap(ad(i,k))%b(ix1,ix2)
            enddo
          enddo
        enddo
      end if

      return
      end
