      subroutine lz_norm(v0,a)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      real(8) :: a,a0
#ifdef cmplx_v
      real(8) :: DZNRM2
#else
      real(8) :: DNRM2
#endif
      integer :: ib,i,k,n
      type(avec) :: v0(isbk1:iebk1)

      a0=0.d0
      do ib=isbk1,iebk1
        do k=1,nfrx(2)
          do i=1,nfrx(1)
            n=size(v0(ib)%ap(ad(i,k))%b)
            if(n.gt.0) then
#ifdef cmplx_v
              a0=a0+DZNRM2(n,v0(ib)%ap(ad(i,k))%b,1)**2
c              write(6,*) v0(ib)%ap(ad(i,k))%b
#else
              a0=a0+DNRM2(n,v0(ib)%ap(ad(i,k))%b,1)**2
#endif
            end if
          enddo
        enddo
      enddo

      call mpi_allreduce(a0,a,1,MPI_REAL8,mpi_sum,newcomm_dmrg,ierr)

      a=sqrt(a)

      return
      end
