      subroutine make_opz()
      use mod_dmrg
      implicit none
#ifdef cmplx_v
      integer :: ix,ix0,ix1,ix2,ix3

      if(allocated(opz)) return

      allocate(opz(nfr,nfr,nop))

!$OMP PARALLEL DO PRIVATE(ix0,ix1,ix2,ix3)
      do ix=1,nop*nfr*nfr
        ix0=mod(ix-1,nfr*nfr)+1
        ix1=mod(ix0-1,nfr)+1
        ix2=(ix0-1)/nfr+1
        ix3=(ix-1)/(nfr*nfr)+1
        opz(ix1,ix2,ix3)=cmplx(op(ix1,ix2,ix3),0.d0,kind=8)
      enddo

      deallocate(op)
#endif

      return
      end
