      module mod_dmrg_mpi
! --- mpi_comm_world
      integer :: 
! --- newcomm_int
     &           newcomm_int,myid_int,np_int,
! --- newcomm_ik (add+bm)
     &           newcomm_tm,myid_tm,np_tm,
! --- newcomm_add
     &           newcomm_add,myid_add,np_add,
! --- newcomm_bm (bk+mx)
     &           newcomm_bm,myid_bm,np_bm,
! --- newcomm_bk
     &           newcomm_bk,myid_bk,np_bk,
! --- newcomm_mx
     &           newcomm_mx,myid_mx,np_mx,
! --- newcomm_sys + newcomm_env
     &           newcomm_se,myid_se,np_se,
! --- newcomm_sys
     &           newcomm_sys,myid_sys,np_sys,
! --- newcomm_env
     &           newcomm_env,myid_env,np_env,
! --- newcomm_mse (1:system, 2:environment)
     &           newcomm_(2),myid_(2),np_(2),
! --- newcomm_vec
     &           newcomm_vec,myid_vec,np_vec,
! --- newcomm_vec + newcomm_env
     &           newcomm_ev,myid_ev,np_ev,
! --- newcomm_ab (add+bk+int)
     &           newcomm_ab,myid_ab,np_ab,
     &           ista_add,iend_add,
     &           ista_int,iend_int,
     &           isbk0,iebk0, !newcomm_bk
     &           isbk1,iebk1, !newcomm_bk+int
     &           isbk2,iebk2, !newcomm_bk+int+add
     &           isbk3,iebk3, !newcomm_bk+int+mx
     &           isbk4,iebk4, !newcomm_bk+int+add+mx
! --- diagonalization (Scalapack)
     &           nprocs,myrank,newcomm,
     &           my_col,size_of_col,npcol,mycol,mpi_comm_col,
     &           my_row,size_of_row,nprow,myrow,mpi_comm_row,
     &           ictxt,
! --- others
     &           ierr,key_rank
      integer,allocatable :: mpist(:),
     &                       kid0(:),kid1(:),
     &                       kid_old(:,:),
     &                       idest_add(:),
     &                       ircnt(:),idisp(:),
     &                       ircnt1(:,:),idisp1(:,:),
     &                       ircnt2(:,:),idisp2(:,:),
     &                       icth4(:),idsh4(:), !parallelization of 2-E data
     &                       np_ma(:)

      type mpi_block
      integer :: ic,icx
      integer,allocatable :: id(:),
     &                       idx(:)
      end type mpi_block
      type(mpi_block),allocatable :: bmpi(:)

      end module mod_dmrg_mpi
