      subroutine mpi_bk(v0,tmpi)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ib,i,k,ic,ih
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: vt(:,:)
      type(avec) :: v0(nbk)
      type(mpi_block) :: tmpi(nbk)

      ih=1

      if(np_bk.eq.1) return

      allocate(mpist(MPI_STATUS_SIZE))
      do ib=1,nbk
        do k=1,nfrx(2)
          do i=1,nfrx(1)
            if(bk(ib,1,ih)%isz(i)*bk(ib,2,ih)%sizex(k).eq.0) cycle

            allocate(vt(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &                  bk(ib,2,ih)%sizex(k)))

            if(kid0(ib).eq.myid_bk) then
              if(.not.allocated(v0(ib)%ap(ad(i,k))%b)) then
                allocate(v0(ib)%ap(ad(i,k))
     &            %b(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &               bk(ib,2,ih)%sizex(k)))
!$OMP PARALLEL WORKSHARE
                v0(ib)%ap(ad(i,k))%b=zero
!$OMP END PARALLEL WORKSHARE
              end if

              do ic=1,tmpi(ib)%ic
                if(tmpi(ib)%id(ic).ne.myid_bk) then
                  call mpi_recv(vt,
     &                     bk(ib,1,ih)%isz(i)*bk(ib,2,ih)%sizex(k),
     &                     mpi_kv,tmpi(ib)%id(ic),(k-1)*nfrx(1)+i,
     &                     newcomm_bk,mpist,ierr)

                  call XAXPY(bk(ib,1,ih)%isz(i)*bk(ib,2,ih)%sizex(k),
     &                       one,vt,1,v0(ib)%ap(ad(i,k))%b,1)
                end if
              enddo
            elseif(tmpi(ib)%ic.eq.1) then
              if(.not.allocated(v0(ib)%ap(ad(i,k))%b)) then
                allocate(v0(ib)%ap(ad(i,k))
     &            %b(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &               bk(ib,2,ih)%sizex(k)))
!$OMP PARALLEL WORKSHARE
                v0(ib)%ap(ad(i,k))%b=zero
!$OMP END PARALLEL WORKSHARE
              end if

              call mpi_send(v0(ib)%ap(ad(i,k))%b,
     &                      bk(ib,1,ih)%isz(i)*bk(ib,2,ih)%sizex(k),
     &                      mpi_kv,kid0(ib),(k-1)*nfrx(1)+i,
     &                      newcomm_bk,ierr)
            end if
            deallocate(vt)
          enddo
        enddo
      enddo
      deallocate(mpist)

      return
      end 
