      subroutine mv_aint(id,vin,vout,bp,cf)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: id,ib,jb,i0,i1,k0,k1,lsta,lend,ix1,ix2,ih
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  cf,zz
      type(avec) :: vin(isbk0:iebk0),vout(nbk)
      type(bop) :: bp(2)

      ih=1

      do ib=isbk0,iebk0
        jb=bp(1)%jbk(ib)
        if(jb.eq.0) cycle
        do i0=1,nfrx(1)
          i1=bp(1)%io(i0)
          do k0=1,nfrx(2)
            k1=bp(2)%io(k0)
            if(i1*k1.eq.0) cycle

            if(bk(jb,1,ih)%sizex(i1)
     &         *bk(jb,2,ih)%sizex(k1).ne.0) then

              call vclear(vout(jb),nv(i1,k1,jb),i1,k1,
     &                    bk(jb,1,ih)%ivs(i1),bk(jb,1,ih)%ive(i1),
     &                    bk(jb,2,ih)%sizex(k1))

              call para_range(1,bk(jb,1,ih)%sizex(i1),np_vec,
     &                        myid_vec,lsta,lend)

              zz=bp(1)%vo(i0)*bp(2)%vo(k0)*cf

!$OMP PARALLEL DO
              do ix2=bk(jb,2,ih)%ivs(k1),bk(jb,2,ih)%ive(k1)
                do ix1=max(bk(jb,1,ih)%ivs(i1),lsta),
     &                 min(bk(jb,1,ih)%ive(i1),lend)
                  vout(jb)%ap(ad(i1,k1))%b(ix1,ix2)
     &              =vout(jb)%ap(ad(i1,k1))%b(ix1,ix2)
     &                +zz*vin(ib)%ap(ad(i0,k0))%b(ix1,ix2)
                enddo
              enddo

            end if
          enddo
        enddo
      enddo

      if(id.eq.0) return

      do ib=isbk0,iebk0
        jb=bp(2)%jbk(ib)
        if(jb.eq.0) cycle
        do i1=1,nfrx(1)
          i0=bp(1)%io(i1)
          do k1=1,nfrx(2)
            k0=bp(2)%io(k1)
            if(i0*k0.eq.0) cycle

            if(bk(jb,1,ih)%sizex(i1)
     &         *bk(jb,2,ih)%sizex(k1).ne.0) then

              call vclear(vout(jb),nv(i1,k1,jb),i1,k1,
     &                    bk(jb,1,ih)%ivs(i1),bk(jb,1,ih)%ive(i1),
     &                    bk(jb,2,ih)%sizex(k1))

              call para_range(1,bk(jb,1,ih)%sizex(i1),np_vec,
     &                        myid_vec,lsta,lend)

#ifdef cmplx_v
              zz=conjg(bp(1)%vo(i1)*bp(2)%vo(k1)*cf)
#else
              zz=bp(1)%vo(i1)*bp(2)%vo(k1)*cf
#endif
!$OMP PARALLEL DO
              do ix2=bk(jb,2,ih)%ivs(k1),bk(jb,2,ih)%ive(k1)
                do ix1=max(bk(jb,1,ih)%ivs(i1),lsta),
     &                 min(bk(jb,1,ih)%ive(i1),lend)
                  vout(jb)%ap(ad(i1,k1))%b(ix1,ix2)
     &              =vout(jb)%ap(ad(i1,k1))%b(ix1,ix2)
     &                +zz*vin(ib)%ap(ad(i0,k0))%b(ix1,ix2)
                enddo
              enddo

            end if
          enddo
        enddo
      enddo

      return
      end
