      subroutine operation(iv1,iv2,ms,ns,ks)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iv1,iv2,ib
      integer :: ms,ns(ms),ks(ms)
      type(avec),allocatable :: va(:,:)

! --- INITIALIZE VECTORS
      allocate(va(nbk,2))
      call init_vtmp(v(isbk1:iebk1,iv1),va(isbk0:iebk0,1))
      do ib=1,nbk 
        allocate(va(ib,2)%ap(ad(nfrx(1),nfrx(2))))
      enddo

! --- OPERATION FOURIER-TRANSFORMED OPERATOR
      call phys_v(va(isbk0:iebk0,1),ms,ns,ks,va(:,2))

! --- SET OPERATED STATE
      call set_vec(va(isbk0:iebk0,2),v(isbk1:iebk1,iv2))

      deallocate(va)

      return
      end
