      subroutine phys_i(va,ax,v0)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ib,i,k,ix1,ix2,ix,lsta,lend,ih
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  ax,a0
      type(avec) :: va(isbk0:iebk0),v0(*)

      ih=1

! --- INNER PRODUCT
      call para_range(1,nfrx(1)*nfrx(2)*(iebk0-isbk0+1),np_vec,myid_vec,
     &                lsta,lend)

      a0=zero
!$OMP PARALLEL DO PRIVATE(ib,i,k) REDUCTION(+:a0)
      do ix=lsta,lend
        ib=(ix-1)/(nfrx(1)*nfrx(2))+isbk0
        i=mod((ix-1)/nfrx(2),nfrx(1))+1
        k=mod(ix-1,nfrx(2))+1
        if(.not.allocated(va(ib)%ap(ad(i,k))%b)) cycle
        if(.not.allocated(v0(ib)%ap(ad(i,k))%b)) cycle
        do ix2=bk(ib,2,ih)%ivs(k),bk(ib,2,ih)%ive(k)
          do ix1=bk(ib,1,ih)%ivs(i),bk(ib,1,ih)%ive(i)
#ifdef cmplx_v
            a0=a0+va(ib)%ap(ad(i,k))%b(ix1,ix2)
     &            *conjg(v0(ib)%ap(ad(i,k))%b(ix1,ix2))
#else
            a0=a0+va(ib)%ap(ad(i,k))%b(ix1,ix2)
     &           *v0(ib)%ap(ad(i,k))%b(ix1,ix2)
#endif
          enddo
        enddo
      enddo

      call mpi_allreduce(a0,ax,1,mpi_kv,mpi_sum,newcomm_tm,ierr)

      return
      end
