      subroutine read_position(file_name,nsite,isp,rx,ry)
      use mod_dmrg_input
      use mod_dmrg_mpi
      implicit none
      include 'mpif.h'
      integer :: nsite,isp(nsite),ix
      real(8) :: rx(nsite),ry(nsite)
      character(32) :: file_name

      if(myid_dmrg.eq.key_rank) then
        open(11,file=file_name,status='old')
        do ix=1,nsite
          read(11,*) isp(ix),rx(ix),ry(ix)
        enddo
        close(11)
      end if
      call mpi_bcast(isp,nsite,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(rx,nsite,MPI_REAL8,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(ry,nsite,MPI_REAL8,key_rank,newcomm_dmrg,ierr)

      return
      end
