      subroutine eigen_init_sclpk()
      use mod_dmrg_mpi
      implicit none
      integer :: sys2blacs_handle

! --- Change here ---
      nprocs=np_mx
      myrank=myid_mx
      newcomm=newcomm_mx

      mpi_comm_col=newcomm_sys
      npcol=np_sys

      mpi_comm_row=newcomm_env
      nprow=np_env
! --- Change here ---

      myrank=myrank+1

      size_of_col = int(sqrt(dble(nprocs)))

      do
        if(size_of_col.le.1) exit
        if(mod(size_of_col,1).eq.0.and.
     &     mod(nprocs,size_of_col).eq.0) exit
          size_of_col=size_of_col-1
      enddo
      size_of_row = nprocs/size_of_col

      my_col=mod(myrank-1,size_of_col)+1
      my_row=(myrank-1)/size_of_col +1

#ifdef sclpk
      ictxt=sys2blacs_handle(newcomm)
      call blacs_gridinit(ictxt,"column-major",nprow,npcol)
      call blacs_gridinfo(ictxt,nprow,npcol,myrow,mycol)
#endif

      return
      end subroutine ! eigen_init
