      subroutine hamil_2(id,id_h,iop,iop0,lop)
      use mod_dmrg
      implicit none
      integer :: id,id_h,iop,iop0,lop(*),it,ib,ix,ix1,ih
#ifdef cmplx_v
      complex(8) :: zz
#else
      real(8) :: zz
#endif
      integer,allocatable :: ks(:)

      ih=1

      if(hamil(iop)%ihs(1).lt.iad(1).and.
     &   hamil(iop)%ihs(2).eq.iad(1).and.
     &   nas.ne.0.and.(id_h.eq.0.or.id_h.eq.1)) then !SYS.BLOCK--SYS.ADDED:1

        if(ck2(iop,1)%num(1)*ck2(iop,1)%num(2).eq.0) return

        do it=1,nit
          zz=zero
          do ix=1,ck2(iop,1)%num(1)
            zz=zz+abs(hamil(ck2(iop,1)%ist(ix,1))%vh(ihcf(it)))
          enddo

          if(abs(ht(it)*zz).lt.dlim_int) cycle

          iop0=iop0+1
          if(id.eq.2) then
            if(iop0.lt.ista_int.or.iop0.gt.iend_int) cycle
            do ix=1,ck2(iop,1)%num(1)
              zz=hamil(ck2(iop,1)%ist(ix,1))%vh(ihcf(it))*ht(it)
              call make_operators(1,hamil(ck2(iop,1)%ist(ix,1))%ihs(1),
     &                            iht(1,it),kop(1,iop0),zz,fsi(it))
            enddo
            th(1)%kh(iop0)=1
            th(1)%ic(iop0)=ihm(it)
            lop(iop0)=1+ishft(it,8)

            allocate(kop(1,iop0)%jbk(nbk),kop(2,iop0)%jbk(nbk),
     &               kop(1,iop0)%fs(nfrx(1)),ks(0))
!$OMP PARALLEL
!$OMP DO
            do ib=1,nbk
              kop(1,iop0)%jbk(ib)=ib
            enddo
!$OMP END DO
!$OMP WORKSHARE
            kop(2,iop0)%jbk=0
            kop(1,iop0)%fs=one
!$OMP END WORKSHARE
!$OMP END PARALLEL
            do ib=1,nbk
              if(kop(1,iop0)%jbk(ib).eq.0) cycle
              kop(2,iop0)%jbk(kop(1,iop0)%jbk(ib))=ib
            enddo

            call init_iv(iop0)

            call single_opx(1,iht(2,it),kop(1,iop0)%io,kop(1,iop0)%vo,
     &                      one)
            if(nae.eq.0) then
              kop(2,iop0)%io(1)=1
              kop(2,iop0)%vo(1)=one
            else
              call single_opx(0,ks,kop(2,iop0)%io,kop(2,iop0)%vo,
     &                        one)
            end if
            deallocate(ks)

            call para_op(th(1)%kh(iop0),th(1)%ic(iop0),
     &                   kop(:,iop0),pop(:,iop0))
          end if
        enddo
      elseif(hamil(iop)%ihs(1).eq.iad(2).and.
     &       hamil(iop)%ihs(2).gt.iad(2).and.
     &       nae.ne.0.and.(id_h.eq.0.or.id_h.eq.2)) then !ENV.ADDED--ENV.BLOCK:2

        if(ck2(iop,2)%num(1)*ck2(iop,2)%num(2).eq.0) return

        do it=1,nit
          zz=zero
          do ix=1,ck2(iop,2)%num(2)
            zz=zz+abs(hamil(ck2(iop,2)%ist(ix,2))%vh(ihcf(it)))
          enddo
          if(abs(ht(it)*zz).lt.dlim_int) cycle

          iop0=iop0+1

          if(id.eq.2) then
            if(iop0.lt.ista_int.or.iop0.gt.iend_int) cycle
            do ix=1,ck2(iop,2)%num(2)
              call make_operators(1,hamil(ck2(iop,2)%ist(ix,2))%ihs(2),
     &                         iht(2,it),kop(2,iop0),
     &                         hamil(ck2(iop,2)%ist(ix,2))%vh(ihcf(it))
     &                         *ht(it),fsi(it))
            enddo
            th(1)%kh(iop0)=2
            th(1)%ic(iop0)=ihm(it)
            lop(iop0)=2+ishft(it,8)

            allocate(kop(1,iop0)%jbk(nbk),kop(2,iop0)%fs(nfrx(2)))
!$OMP PARALLEL
!$OMP WORKSHARE
            kop(2,iop0)%fs=one
!$OMP END WORKSHARE NOWAIT
!$OMP DO
            do ib=1,nbk
              kop(1,iop0)%jbk(ib)=ib
            enddo
!$OMP END DO
!$OMP END PARALLEL

            call init_iv(iop0)

            if(nas.eq.0) then
              kop(1,iop0)%io(1)=1
              kop(1,iop0)%vo(1)=one
            else
              allocate(ks(0))
              call single_opx(0,ks,kop(1,iop0)%io,kop(1,iop0)%vo,
     &                        one)
              deallocate(ks)
            end if

            call single_opx(1,iht(1,it),kop(2,iop0)%io,kop(2,iop0)%vo,
     &                      one)

            call para_op(th(1)%kh(iop0),th(1)%ic(iop0),
     &                   kop(:,iop0),pop(:,iop0))
          end if 
        enddo
      elseif(hamil(iop)%ihs(1).lt.iad(1).and.
     &       hamil(iop)%ihs(2).eq.iad(2).and.
     &       nae.ne.0.and.id_h.eq.0) then !SYS.BLOCK--ENV.ADDED:3 -- mv_sint

        if(ck2(iop,1)%num(1)*ck2(iop,1)%num(2).eq.0) return

        do it=1,nit
          zz=zero
          do ix=1,ck2(iop,1)%num(1)
            zz=zz+abs(hamil(ck2(iop,1)%ist(ix,1))%vh(ihcf(it)))
          enddo

          if(abs(ht(it)*zz).lt.dlim_int) cycle

          iop0=iop0+1
          if(id.eq.2) then
            if(iop0.lt.ista_int.or.iop0.gt.iend_int) cycle
            do ix=1,ck2(iop,1)%num(1)
              zz=hamil(ck2(iop,1)%ist(ix,1))%vh(ihcf(it))*ht(it)
              call make_operators(1,hamil(ck2(iop,1)%ist(ix,1))%ihs(1),
     &                            iht(1,it),kop(1,iop0),zz,fsi(it))
            enddo
            th(1)%kh(iop0)=3
            th(1)%ic(iop0)=ihm(it)
            lop(iop0)=3+ishft(it,8)

            allocate(kop(1,iop0)%jbk(nbk))
!$OMP PARALLEL DO
            do ib=1,nbk
              kop(1,iop0)%jbk(ib)=bk(ib,1,ih)%ibs(-1,abs(iht(1,it)))
            enddo

            call fermi_sign(1,iop0,it)

            call init_iv(iop0)

            if(nas.eq.0) then
              kop(1,iop0)%io(1)=1
              kop(1,iop0)%vo(1)=one
            else
              allocate(ks(0))
              call single_opx(0,ks,kop(1,iop0)%io,kop(1,iop0)%vo,
     &                        one)
              deallocate(ks)
            end if
            call single_opx(1,iht(2,it),kop(2,iop0)%io,kop(2,iop0)%vo,
     &                      one)

            call para_op(th(1)%kh(iop0),th(1)%ic(iop0),
     &                   kop(:,iop0),pop(:,iop0))
          end if
        enddo
      elseif(hamil(iop)%ihs(1).eq.iad(1).and.
     &       hamil(iop)%ihs(2).gt.iad(2).and.
     &       nas.ne.0.and.id_h.eq.0) then !SYS.ADDED--ENV.BLOCK:4

        if(ck2(iop,2)%num(1)*ck2(iop,2)%num(2).eq.0) return

        do it=1,nit
          zz=zero
          do ix=1,ck2(iop,2)%num(2)
            zz=zz+abs(hamil(ck2(iop,2)%ist(ix,2))%vh(ihcf(it)))
          enddo

          if(abs(ht(it)*zz).lt.dlim_int) cycle

          iop0=iop0+1
          if(id.eq.2) then
            if(iop0.lt.ista_int.or.iop0.gt.iend_int) cycle
            do ix=1,ck2(iop,2)%num(2)
              call make_operators(1,hamil(ck2(iop,2)%ist(ix,2))%ihs(2),
     &                         iht(2,it),kop(2,iop0),
     &                         hamil(ck2(iop,2)%ist(ix,2))%vh(ihcf(it))
     &                         *ht(it),fsi(it))
            enddo
            th(1)%kh(iop0)=4
            th(1)%ic(iop0)=ihm(it)
            lop(iop0)=4+ishft(it,8)

            allocate(kop(1,iop0)%jbk(nbk))
!$OMP PARALLEL DO
            do ib=1,nbk
              kop(1,iop0)%jbk(ib)=bk(ib,1,ih)%ibs(-1,abs(iht(1,it)))
            enddo

            call fermi_sign(2,iop0,it)

            call init_iv(iop0)

            call single_opx(1,iht(1,it),kop(1,iop0)%io,kop(1,iop0)%vo,
     &                      one)
            if(nae.eq.0) then
              kop(2,iop0)%io(1)=1
              kop(2,iop0)%vo(1)=one
            else
              allocate(ks(0))
              call single_opx(0,ks,kop(2,iop0)%io,kop(2,iop0)%vo,
     &                        one)
              deallocate(ks)
            end if

            call para_op(th(1)%kh(iop0),th(1)%ic(iop0),
     &                   kop(:,iop0),pop(:,iop0))

          end if
        enddo
      elseif(hamil(iop)%ihs(1).lt.iad(1).and.
     &       hamil(iop)%ihs(2).gt.iad(2).and.id_h.eq.0) then !SYS.BLOCK--ENV.BLOCK:5

        if(ck2(iop,0)%num(1)*ck2(iop,0)%num(2).eq.0) return

        do it=1,nit
          zz=zero
          if(ck2(iop,0)%num(2).eq.1) then
            do ix=1,ck2(iop,0)%num(1)
              zz=zz+abs(hamil(ck2(iop,0)%ist(ix,1))%vh(ihcf(it)))
            enddo
          else
            do ix=1,ck2(iop,0)%num(2)
              zz=zz+abs(hamil(ck2(iop,0)%ist(ix,2))%vh(ihcf(it)))
            enddo
          end if

          if(abs(ht(it)*zz).lt.dlim_int) cycle

          iop0=iop0+1
          if(id.eq.2) then
            if(iop0.lt.ista_int.or.iop0.gt.iend_int) cycle
            th(1)%kh(iop0)=5
            th(1)%ic(iop0)=ihm(it)
            lop(iop0)=5+ishft(it,8)

            if(ck2(iop,0)%num(2).eq.1) then
              do ix=1,ck2(iop,0)%num(1)
                zz=hamil(ck2(iop,0)%ist(ix,1))%vh(ihcf(it))*ht(it)
                call make_operators(1,hamil(ck2(iop,0)%ist(ix,1)) !
     &                         %ihs(1),iht(1,it),kop(1,iop0),zz,fsi(it))
              enddo
              call make_operators(1,hamil(iop)%ihs(2), !
     &                            iht(2,it),kop(2,iop0),one,fsi(it))

            else
              call make_operators(1,hamil(iop)%ihs(1), !
     &                            iht(1,it),kop(1,iop0),one,fsi(it))
              do ix=1,ck2(iop,0)%num(2)
                call make_operators(1,hamil(ck2(iop,0)%ist(ix,2)) !
     &                          %ihs(2),iht(2,it),kop(2,iop0),
     &                          hamil(ck2(iop,0)%ist(ix,2))%vh(ihcf(it))
     &                          *ht(it),fsi(it))
              enddo
            end if

            call fermi_sign(1,iop0,it)
            call fermi_sign(2,iop0,it)

            allocate(kop(1,iop0)%jbk(nbk),ks(0))
!$OMP PARALLEL DO
            do ib=1,nbk
              kop(1,iop0)%jbk(ib)=bk(ib,1,ih)%ibs(-1,abs(iht(1,it)))
            enddo

            call init_iv(iop0)

            if(nas.eq.0) then
              kop(1,iop0)%io(1)=1
              kop(1,iop0)%vo(1)=one
            else
              call single_opx(0,ks,kop(1,iop0)%io,kop(1,iop0)%vo,one)
            end if

            if(nae.eq.0) then
              kop(2,iop0)%io(1)=1
              kop(2,iop0)%vo(1)=one
            else
              call single_opx(0,ks,kop(2,iop0)%io,kop(2,iop0)%vo,one)
            end if
            deallocate(ks)

            call para_op(th(1)%kh(iop0),th(1)%ic(iop0),
     &                   kop(:,iop0),pop(:,iop0))
          end if
        enddo

      elseif(hamil(iop)%ihs(1).eq.iad(1).and.
     &       hamil(iop)%ihs(2).eq.iad(2).and.
     &       nas*nae.ne.0.and.id_h.eq.0) then !SYS.ADDED-ENV.ADDED:6
        do it=1,nit
          if(abs(ht(it)*hamil(iop)%vh(ihcf(it))).lt.dlim_int) cycle
          iop0=iop0+1
          if(id.eq.2) then
            if(iop0.lt.ista_int.or.iop0.gt.iend_int) cycle
            th(1)%kh(iop0)=6
            th(1)%ic(iop0)=ihm(it)

            allocate(kop(1,iop0)%jbk(nbk))
!$OMP PARALLEL
!$OMP DO
            do ib=1,nbk
              kop(1,iop0)%jbk(ib)=bk(ib,1,ih)%ibs(-1,abs(iht(1,it)))
            enddo
!$OMP END DO
!$OMP END PARALLEL

            call init_iv(iop0)

            zz=hamil(iop)%vh(ihcf(it))*ht(it)*one
            call single_opx(1,iht(1,it),kop(1,iop0)%io,kop(1,iop0)%vo,
     &                      zz)

            call single_opx(1,iht(2,it),kop(2,iop0)%io,kop(2,iop0)%vo,
     &                      one)
          end if
        enddo
      elseif(hamil(iop)%ihs(1).eq.iad(1).and.
     &       hamil(iop)%ihs(2).eq.iad(1).and.
     &       nas.ne.0.and.id_h.eq.0) then !SYSTEM ADDED:7
        iop0=iop0+1
        if(id.eq.2.and.(iop0.ge.ista_int.and.iop0.le.iend_int)) then
          th(1)%kh(iop0)=7
          th(1)%ic(iop0)=0
          allocate(kop(1,iop0)%jbk(nbk))
!$OMP PARALLEL DO
          do ib=1,nbk
            kop(1,iop0)%jbk(ib)=ib
          enddo

          call init_iv(iop0)

          do ix1=1,2
            call single_opx(2,iht(:,ix1),kop(1,iop0)%io,kop(1,iop0)%vo,
     &                      hamil(iop)%vh(1)*one)
          enddo
          if(nae.eq.0) then
            kop(2,iop0)%io(1)=1
            kop(2,iop0)%vo(1)=one
          else
            allocate(ks(0))
            call single_opx(0,ks,kop(2,iop0)%io,kop(2,iop0)%vo,one)
            deallocate(ks)
          end if
        end if
      elseif(hamil(iop)%ihs(1).eq.iad(2).and.
     &       hamil(iop)%ihs(2).eq.iad(2).and.
     &       nae.ne.0.and.id_h.eq.0) then !ENVIRONMENT ADDED:8
        iop0=iop0+1
        if(id.eq.2.and.(iop0.ge.ista_int.and.iop0.le.iend_int)) then
          th(1)%kh(iop0)=8
          th(1)%ic(iop0)=0
          allocate(kop(1,iop0)%jbk(nbk))
!$OMP PARALLEL DO
          do ib=1,nbk
            kop(1,iop0)%jbk(ib)=ib
          enddo

          call init_iv(iop0)

          if(nas.eq.0) then
            kop(1,iop0)%io(1)=1
            kop(1,iop0)%vo(1)=one
          else
            allocate(ks(0))
            call single_opx(0,ks,kop(1,iop0)%io,kop(1,iop0)%vo,one)
            deallocate(ks)
          end if
          do ix1=1,2
            call single_opx(2,iht(:,ix1),kop(2,iop0)%io,kop(2,iop0)%vo,
     &                      hamil(iop)%vh(1)*one)
          enddo
        end if
      end if

      return
      end
