      subroutine hamil_c(id,iop,iop0)
      use mod_dmrg
      implicit none
      integer :: iop,iop0,id,ib,ix,ix1
      integer,allocatable :: ks(:)

      if(hamil(iop)%ihs(1).eq.iad(1).and.
     &   hamil(iop)%ihs(3).eq.iad(1).and.nas.ne.0) then !system added
        iop0=iop0+1
        if(id.eq.2.and.(iop0.ge.ista_int.and.iop0.le.iend_int)) then
          th(1)%kh(iop0)=7
          th(1)%ic(iop0)=0
          allocate(kop(1,iop0)%jbk(nbk),
     &             kop(1,iop0)%io(nfr),kop(1,iop0)%vo(nfr),
     &             kop(2,iop0)%io(nfr),kop(2,iop0)%vo(nfr))
!$OMP PARALLEL
!$OMP WORKSHARE
          kop(1,iop0)%io=0
          kop(1,iop0)%vo=zero
          kop(2,iop0)%io=0
          kop(2,iop0)%vo=zero
!$OMP END WORKSHARE NOWAIT
!$OMP DO
          do ib=1,nbk
            kop(1,iop0)%jbk(ib)=ib
          enddo
!$OMP END DO
!$OMP END PARALLEL
          call single_opx(4,iht,kop(1,iop0)%io,kop(1,iop0)%vo,
     &                    one*hamil(iop)%vh(ihcf(nit+1)))
          allocate(ks(0))
          call single_opx(0,ks,kop(2,iop0)%io,kop(2,iop0)%vo,one)
          deallocate(ks)

        end if

      elseif(hamil(iop)%ihs(1).eq.iad(2).and.
     &       hamil(iop)%ihs(3).eq.iad(2).and.nae.ne.0) then !environment added
        iop0=iop0+1
        if(id.eq.2.and.(iop0.ge.ista_int.and.iop0.le.iend_int)) then
          th(1)%kh(iop0)=8
          th(1)%ic(iop0)=0
          allocate(kop(1,iop0)%jbk(nbk),
     &             kop(1,iop0)%io(nfr),kop(1,iop0)%vo(nfr),
     &             kop(2,iop0)%io(nfr),kop(2,iop0)%vo(nfr),ks(0))
!$OMP PARALLEL
!$OMP WORKSHARE
          kop(1,iop0)%io=0
          kop(1,iop0)%vo=zero
          kop(2,iop0)%io=0
          kop(2,iop0)%vo=zero
!$OMP END WORKSHARE NOWAIT
!$OMP DO
          do ib=1,nbk
            kop(1,iop0)%jbk(ib)=ib
          enddo
!$OMP END DO
!$OMP END PARALLEL
          call single_opx(0,ks,kop(1,iop0)%io,kop(1,iop0)%vo,one)
          deallocate(ks)
          call single_opx(4,iht,kop(2,iop0)%io,kop(2,iop0)%vo,
     &                    one*hamil(iop)%vh(ihcf(nit+1)))
        end if

      elseif((hamil(iop)%ihs(1).eq.iad(1).and.nas.ne.0).and.
     &       (hamil(iop)%ihs(3).eq.iad(2).and.nae.ne.0)) then !system and environment added
        iop0=iop0+1
        if(id.eq.2.and.(iop0.ge.ista_int.and.iop0.le.iend_int)) then
          th(1)%kh(iop0)=6
          th(1)%ic(iop0)=0
          allocate(kop(1,iop0)%io(nfr),kop(1,iop0)%vo(nfr),
     &             kop(2,iop0)%io(nfr),kop(2,iop0)%vo(nfr),
     &             kop(1,iop0)%jbk(nbk))
!$OMP PARALLEL
!$OMP WORKSHARE
          kop(1,iop0)%io=0
          kop(1,iop0)%vo=zero
          kop(2,iop0)%io=0
          kop(2,iop0)%vo=zero
!$OMP END WORKSHARE NOWAIT
!$OMP DO
          do ib=1,nbk
            kop(1,iop0)%jbk(ib)=ib
          enddo
!$OMP END DO
!$OMP END PARALLEL
          do ix1=1,2
            call single_opx(2,iht(:,ix1),kop(1,iop0)%io,kop(1,iop0)%vo,
     &                      one*hamil(iop)%vh(ihcf(nit+1)))
            call single_opx(2,iht(:,ix1),kop(2,iop0)%io,kop(2,iop0)%vo,
     &                      one)
          enddo
        end if

      elseif(hamil(iop)%ihs(1).lt.iad(1).and.
     &       hamil(iop)%ihs(3).eq.iad(1).and.nas.ne.0) then !system block and added
        if(ckc(iop,1)%num(1)*ckc(iop,1)%num(2).eq.0) return
        iop0=iop0+1
        if(id.eq.2.and.(iop0.ge.ista_int.and.iop0.le.iend_int)) then
          th(1)%kh(iop0)=1
          th(1)%ic(iop0)=0
          allocate(kop(1,iop0)%io(nfr),kop(1,iop0)%vo(nfr),
     &             kop(2,iop0)%io(nfr),kop(2,iop0)%vo(nfr),
     &             kop(1,iop0)%jbk(nbk),kop(1,iop0)%fs(nfr),ks(0))
!$OMP PARALLEL
!$OMP WORKSHARE
          kop(1,iop0)%io=0
          kop(1,iop0)%vo=zero
          kop(2,iop0)%io=0
          kop(2,iop0)%vo=zero
          kop(1,iop0)%fs=one
!$OMP END WORKSHARE NOWAIT
!$OMP DO
          do ib=1,nbk
            kop(1,iop0)%jbk(ib)=ib
          enddo
!$OMP END DO
!$OMP END PARALLEL
          call single_opx(0,ks,kop(2,iop0)%io,kop(2,iop0)%vo,one)
          deallocate(ks)
          do ix=1,ckc(iop,1)%num(1)
            do ix1=1,2
              call make_operators(2,hamil(ckc(iop,1)%ist(ix,1)) !
     &                 %ihs(1:2),iht(:,ix1),kop(1,iop0),
     &                 one*hamil(ckc(iop,1)%ist(ix,1))%vh(ihcf(nit+1)),
     &                 1.d0)
            enddo
          enddo
          do ix1=1,2
            call single_opx(2,iht(:,ix1),kop(1,iop0)%io,kop(1,iop0)%vo,
     &                      one)
          enddo

          call para_op(th(1)%kh(iop0),th(1)%kh(iop0),
     &                 kop(:,iop0),pop(:,iop0))
        end if

      elseif(hamil(iop)%ihs(1).lt.iad(1).and.
     &       hamil(iop)%ihs(3).eq.iad(2).and.nae.ne.0) then !system block and environment added
        if(ckc(iop,1)%num(1)*ckc(iop,1)%num(2).eq.0) return
        iop0=iop0+1
        if(id.eq.2.and.(iop0.ge.ista_int.and.iop0.le.iend_int)) then
          th(1)%kh(iop0)=3
          th(1)%ic(iop0)=0
          allocate(kop(1,iop0)%jbk(nbk),kop(1,iop0)%fs(nfr),
     &             kop(1,iop0)%io(nfr),kop(1,iop0)%vo(nfr),
     &             kop(2,iop0)%io(nfr),kop(2,iop0)%vo(nfr),ks(0))
!$OMP PARALLEL
!$OMP WORKSHARE
          kop(1,iop0)%io=0
          kop(1,iop0)%vo=zero
          kop(2,iop0)%io=0
          kop(2,iop0)%vo=zero
          kop(1,iop0)%fs=one
!$OMP END WORKSHARE NOWAIT
!$OMP DO
          do ib=1,nbk
            kop(1,iop0)%jbk(ib)=ib
          enddo
!$OMP END DO
!$OMP END PARALLEL
          call single_opx(0,ks,kop(1,iop0)%io,kop(1,iop0)%vo,one)
          deallocate(ks)
          do ix=1,ckc(iop,1)%num(1)
            do ix1=1,2
              call make_operators(2,hamil(ckc(iop,1)%ist(ix,1)) !
     &                 %ihs(1:2),iht(:,ix1),kop(1,iop0),
     &                 one*hamil(ckc(iop,1)%ist(ix,1))%vh(ihcf(nit+1)),
     &                 1.d0)
            enddo
          enddo
          do ix1=1,2
            call single_opx(2,iht(:,ix1),kop(2,iop0)%io,kop(2,iop0)%vo,
     &                      one)
          enddo

          call para_op(th(1)%kh(iop0),th(1)%kh(iop0),
     &                 kop(:,iop0),pop(:,iop0))

        end if

      elseif((hamil(iop)%ihs(1).eq.iad(2).and.nae.ne.0).and.
     &       hamil(iop)%ihs(3).gt.iad(2)) then !environment added and block
        if(ckc(iop,2)%num(1)*ckc(iop,2)%num(2).eq.0) return
        iop0=iop0+1
        if(id.eq.2.and.(iop0.ge.ista_int.and.iop0.le.iend_int)) then
          th(1)%kh(iop0)=2
          th(1)%ic(iop0)=0
          allocate(kop(1,iop0)%jbk(nbk),kop(2,iop0)%fs(nfr),
     &             kop(1,iop0)%io(nfr),kop(1,iop0)%vo(nfr),
     &             kop(2,iop0)%io(nfr),kop(2,iop0)%vo(nfr),ks(0))
!$OMP PARALLEL
!$OMP WORKSHARE
          kop(1,iop0)%io=0
          kop(1,iop0)%vo=zero
          kop(2,iop0)%io=0
          kop(2,iop0)%vo=zero
          kop(2,iop0)%fs=one
!$OMP END WORKSHARE NOWAIT
!$OMP DO
          do ib=1,nbk
            kop(1,iop0)%jbk(ib)=ib
          enddo
!$OMP END DO
!$OMP END PARALLEL
          call single_opx(0,ks,kop(1,iop0)%io,kop(1,iop0)%vo,one)
          deallocate(ks)
          do ix1=1,2
            call single_opx(2,iht(:,ix1),kop(2,iop0)%io,kop(2,iop0)%vo,
     &                      one)
          enddo
          do ix=1,ckc(iop,2)%num(2)
            do ix1=1,2
              call make_operators(2,hamil(ckc(iop,2)%ist(ix,2)) !
     &                 %ihs(3:4),iht(:,ix1),kop(2,iop0),
     &                 one*hamil(ckc(iop,2)%ist(ix,2))%vh(ihcf(nit+1)),
     &                 1.d0)
            enddo
          enddo

          call para_op(th(1)%kh(iop0),th(1)%kh(iop0),
     &                 kop(:,iop0),pop(:,iop0))

        end if

      elseif((hamil(iop)%ihs(1).eq.iad(1).and.nas.ne.0).and.
     &       hamil(iop)%ihs(3).gt.iad(2)) then !system added and environment block
        if(ckc(iop,2)%num(1)*ckc(iop,2)%num(2).eq.0) return
        iop0=iop0+1
        if(id.eq.2.and.(iop0.ge.ista_int.and.iop0.le.iend_int)) then
          th(1)%kh(iop0)=4
          th(1)%ic(iop0)=0
          allocate(kop(1,iop0)%jbk(nbk),kop(2,iop0)%fs(nfr),
     &             kop(1,iop0)%io(nfr),kop(1,iop0)%vo(nfr),
     &             kop(2,iop0)%io(nfr),kop(2,iop0)%vo(nfr))
!$OMP PARALLEL
!$OMP WORKSHARE
          kop(1,iop0)%io=0
          kop(1,iop0)%vo=zero
          kop(2,iop0)%io=0
          kop(2,iop0)%vo=zero
          kop(2,iop0)%fs=one
!$OMP END WORKSHARE NOWAIT
!$OMP DO
          do ib=1,nbk
            kop(1,iop0)%jbk(ib)=ib
          enddo
!$OMP END DO
!$OMP END PARALLEL
          do ix1=1,2
            call single_opx(2,iht(:,ix1),kop(1,iop0)%io,kop(1,iop0)%vo,
     &                      one)
          enddo
          do ix=1,ckc(iop,2)%num(2)
            do ix1=1,2
              call make_operators(2,hamil(ckc(iop,2)%ist(ix,2)) !
     &                 %ihs(3:4),iht(:,ix1),kop(2,iop0),
     &                 one*hamil(ckc(iop,2)%ist(ix,2))%vh(ihcf(nit+1)),
     &                 1.d0)
            enddo
          enddo
          allocate(ks(0))
          call single_opx(0,ks,kop(2,iop0)%io,kop(2,iop0)%vo,one)
          deallocate(ks)

          call para_op(th(1)%kh(iop0),th(1)%kh(iop0),
     &                 kop(:,iop0),pop(:,iop0))

        end if

      elseif(hamil(iop)%ihs(1).lt.iad(1).and.
     &       hamil(iop)%ihs(3).gt.iad(2)) then !system block and environment block
        if(ckc(iop,0)%num(1)*ckc(iop,0)%num(2).eq.0) return
        iop0=iop0+1
        if(id.eq.2.and.(iop0.ge.ista_int.and.iop0.le.iend_int)) then
          th(1)%kh(iop0)=5
          th(1)%ic(iop0)=0
          allocate(kop(1,iop0)%jbk(nbk),
     &             kop(1,iop0)%fs(nfr),kop(2,iop0)%fs(nfr),
     &             kop(1,iop0)%io(nfr),kop(1,iop0)%vo(nfr),
     &             kop(2,iop0)%io(nfr),kop(2,iop0)%vo(nfr),ks(0))
!$OMP PARALLEL
!$OMP WORKSHARE
          kop(1,iop0)%io=0
          kop(1,iop0)%vo=zero
          kop(2,iop0)%io=0
          kop(2,iop0)%vo=zero
          kop(1,iop0)%fs=one
          kop(2,iop0)%fs=one
!$OMP END WORKSHARE NOWAIT
!$OMP DO
          do ib=1,nbk
            kop(1,iop0)%jbk(ib)=ib
          enddo
!$OMP END DO
!$OMP END PARALLEL
          call single_opx(0,ks,kop(1,iop0)%io,kop(1,iop0)%vo,one)
          call single_opx(0,ks,kop(2,iop0)%io,kop(2,iop0)%vo,one)
          deallocate(ks)
          if(ckc(iop,0)%num(1).eq.1) then
            do ix1=1,2
              call make_operators(2,hamil(iop)%ihs(1:2),iht(:,ix1), !
     &                            kop(1,iop0),one,1.d0)
            enddo
            do ix=1,ckc(iop,0)%num(2)
              do ix1=1,2
                call make_operators(2,hamil(ckc(iop,0)%ist(ix,2)) !
     &                %ihs(3:4),iht(:,ix1),kop(2,iop0),
     &                one*hamil(ckc(iop,0)%ist(ix,2))%vh(ihcf(nit+1)),
     &                1.d0)
              enddo
            enddo
          elseif(ckc(iop,0)%num(2).eq.1) then
            do ix=1,ckc(iop,0)%num(1)
              do ix1=1,2
                call make_operators(2,hamil(ckc(iop,0)%ist(ix,1)) !
     &                 %ihs(1:2),iht(:,ix1),kop(1,iop0),
     &                 one*hamil(ckc(iop,0)%ist(ix,1))%vh(ihcf(nit+1)),
     &                 1.d0)
              enddo
            enddo
            do ix1=1,2
              call make_operators(2,hamil(iop)%ihs(3:4),iht(:,ix1), !
     &                            kop(2,iop0),one,1.d0)
            enddo
          end if

          call para_op(th(1)%kh(iop0),th(1)%kh(iop0),
     &                 kop(:,iop0),pop(:,iop0))

        end if
      end if

      return
      end
