      subroutine make_hamil_4(iop,iop0,itsta,itend)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iop,iop0,itsta,itend,iopx,itx(4),it,ix,ib,ix1,ix2,
     &           nx(2),num(4),itm(2),ih
      real(8) :: bx(4),bf
      integer,allocatable :: msx(:),nsx(:,:),ksx(:,:)

      ih=1

      allocate(kop(1,iop0)%io(nfr),kop(1,iop0)%vo(nfr),
     &         kop(2,iop0)%io(nfr),kop(2,iop0)%vo(nfr),
     &         kop(1,iop0)%jbk(nbk),
     &         kop(1,iop0)%fs(nfr),kop(2,iop0)%fs(nfr),
     &         msx(4),nsx(4,4),ksx(4,4),iex(4,2))

!$OMP PARALLEL WORKSHARE
      kop(1,iop0)%io=0
      kop(1,iop0)%vo=0.d0
      kop(2,iop0)%io=0
      kop(2,iop0)%vo=0.d0
      bx=1.d0
      iex=0
!$OMP END PARALLEL WORKSHARE

      do ix=1,ck4(iop,0)%num(0)
        do it=itsta,itend
          iopx=ck4(iop,0)%ist(ix,1)

          call make_itx(iopx,it,itx)

          call check_op(4,hamil(iopx)%ihs,itx,msx,nsx,ksx,bf)

          if(it.eq.itsta) then
            num(1:4)=ck4(iopx,0)%num(1:4)
          elseif(it.eq.itsta+1) then
            if(msx(1).eq.3) then
              num(1:4)=(/1,0,0,0/)
            elseif(msx(4).eq.3) then
              num(1:4)=(/0,0,0,1/)
            end if
          end if

          if(msx(4).eq.3.and.kd4(iopx).eq.7) then
            itm(1:2)=itx(1:2)
            itx(1:2)=itx(3:4)
            itx(3:4)=itm(1:2)
            call check_op(4,hamil(iopx)%ihs,itx,msx,nsx,ksx,bf)
          end if

          if(msx(4).eq.0) then
            if(msx(3).eq.0) then
              th(1)%kh(iop0)=1
              bx(1)=bf*hamil(iopx)%vh(ihcf(nit+1))
            elseif(msx(1).eq.0) then !added--added
              th(1)%kh(iop0)=6
              bx(2)=bf*hamil(iopx)%vh(ihcf(nit+1))
            else
              th(1)%kh(iop0)=3
              bx(1)=bf*hamil(iopx)%vh(ihcf(nit+1))
            end if
          elseif(msx(1).eq.0) then
            if(msx(2).eq.0) then
              th(1)%kh(iop0)=2
              bx(4)=bf*hamil(iopx)%vh(ihcf(nit+1))
            else
              th(1)%kh(iop0)=4
              bx(4)=bf*hamil(iopx)%vh(ihcf(nit+1))
            end if
          else
            th(1)%kh(iop0)=5
            if(iand(ck4(iop,0)%ityp,1).eq.0) then
              bx(1)=bf*hamil(iopx)%vh(ihcf(nit+1))
            else
              bx(4)=bf*hamil(iopx)%vh(ihcf(nit+1))
            end if
          end if

          call make_hamil_c4(iop0,num,msx,nsx,ksx,bx)

        enddo
      enddo

!!! BLOCK INFO.
      nx=0
      do ix2=1,4
c        if(hamil(iopx)%ihs(ix2).le.iad(1)) then
        if(hamil(iopx)%ihs(ix2).lt.iad(1)+nas) then
          nx(abs(itx(ix2)))=nx(abs(itx(ix2)))+sign(1,itx(ix2))
        end if
      enddo

      do ib=1,nbk
        kop(1,iop0)%jbk(ib)=ib
        do ix1=1,2
          do ix2=1,abs(nx(ix1))
            if(kop(1,iop0)%jbk(ib).eq.0) exit
            kop(1,iop0)%jbk(ib)
     &        =bk(kop(1,iop0)%jbk(ib),1,ih)%ibs(-sign(1,nx(ix1)),ix1)
          enddo
        enddo
      enddo

c      if(ck4(iop,0)%num(0).ne.1) then
c          write(6,*) ix,'A',hamil(iopx)%ihs
c          write(6,*) ix,'B',itx
cc          write(6,*) 'x',ksx(:,1),ix
cc          write(6,*) 'y',nsx(:,1),ix
c      end if

!!!!! fermion sign for added sites !!!!!
      do ix1=1,2
        nx=0
        do ix2=1,3,2
          if(hamil(iopx)%ihs(ix2).lt.iad(ix1).and.
     &       hamil(iopx)%ihs(ix2+1).gt.iad(ix1)) then
            nx(abs(itx(ix2)))=nx(abs(itx(ix2)))+1
          end if
        enddo

        if(iftp.eq.1) then
          do ix2=1,nfrx(ix1)
            kop(ix1,iop0)%fs(ix2)=(fsi(0)**(nx(1)*iud(ix2,1)))
     &                           *(fsi(0)**(nx(2)*iud(ix2,2)))
          enddo
        elseif(iftp.eq.2) then
          do ix2=1,nfrx(ix1)
            kop(ix1,iop0)%fs(ix2)=fsi(0)
     &        **((nx(1)+nx(2))*(iud(ix2,1)+iud(ix2,2)))
          enddo
        else
          do ix2=1,nfrx(ix1)
            kop(ix1,iop0)%fs(ix2)=1.d0
          enddo
        end if
      enddo

      deallocate(msx,nsx,ksx,iex)

      return
      end
