      subroutine mpi_uv_wf(ise,nx)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ise,nx,ib,lb,jb,i,k,iac,lsta,lend,lsize,ix,kx,ih

      ih=1

      if(np_bk.eq.1) return

      allocate(mpist(MPI_STATUS_SIZE))
      if(ise.eq.1) then
        do ib=1,nbk
          do i=1,nfrx(1)
            do k=1,nfrx(2)
              lb=bk(ib,1,ih)%ap(ad(i,k))%nse(1+mod(ise,2))
              if(lb.eq.0) cycle
              if(nas*nae.eq.0) then
                jb=vx(lb)%jlb(1)
                ix=k
              else
                jb=vx(lb)%jlb(k)
                ix=i
              end if
              if(jb.eq.0.or.jb.gt.block(ise,nx,mh)%nbk) cycle
              if(kid0(ib).eq.block(ise,nx,mh)%kid(jb)) cycle

              iac=0; lsize=0
              if(kid0(ib).eq.myid_bk) then
                if(.not.allocated(block(ise,nx,mh)%b(jb)%s(ix)%uv)) then
                  iac=1
                  call para_range(1,block(ise,nx,mh)%sizex(jb,ix),
     &                            np_env,myid_env,lsta,lend)
                  lsize=lend-lsta+1
                  allocate(block(ise,nx,mh)%b(jb)%s(ix)
     &                     %uv(lsta:lend,
     &                         block(ise,nx,mh)%ista0(jb,1):
     &                         block(ise,nx,mh)%iend0(jb,1)))

                  mem_uv=mem_uv+8*size(block(ise,nx,mh)%b(jb)%s(ix)%uv)
                end if
              end if
              call mpi_bcast(iac,1,mpi_integer,kid0(ib),newcomm_bk,ierr)

              if(iac.ne.0) then
                if(myid_bk.eq.block(ise,nx,mh)%kid(jb)) then
                  call para_range(1,block(ise,nx,mh)%sizex(jb,ix),
     &                            np_env,myid_env,lsta,lend)
                  lsize=lend-lsta+1
                  call mpi_send(block(ise,nx,mh)%b(jb)%s(ix)
     &                          %uv(:,block(ise,nx,mh)%ista0(jb,1):
     &                                block(ise,nx,mh)%iend0(jb,1)),
     &                          lsize
     &                         *block(ise,nx,mh)%isize0(jb,1),
     &                          mpi_double_precision,
     &                          kid0(ib),
     &                          ib*1000+jb,
     &                          newcomm_bk,ierr)
                elseif(myid_bk.eq.kid0(ib)) then
                  call mpi_recv(block(ise,nx,mh)%b(jb)%s(ix)
     &                          %uv(:,block(ise,nx,mh)%ista0(jb,1):
     &                                block(ise,nx,mh)%iend0(jb,1)),
     &                          lsize
     &                         *block(ise,nx,mh)%isize0(jb,1),
     &                          mpi_double_precision,
     &                          block(ise,nx,mh)%kid(jb),
     &                          ib*1000+jb,
     &                          newcomm_bk,mpist,ierr)
                end if
              end if
            enddo
          enddo
        enddo

      elseif(ise.eq.2) then
        do ib=1,nbk
          do i=1,nfrx(1)
            do k=1,nfrx(2)
              lb=bk(ib,1,ih)%ap(ad(i,k))%nse(1+mod(ise,2))
              if(lb.eq.0) cycle

              if(nas*nae.eq.0) then
                jb=vx(lb)%jlb(1)
                kx=i
              else
                jb=vx(lb)%jlb(i)
                kx=k
              end if

              if(jb.eq.0.or.jb.gt.block(ise,nx,mh)%nbk) cycle
              if(kid0(ib).eq.block(ise,nx,mh)%kid(jb)) cycle

              iac=0; lsize=0
              if(kid0(ib).eq.myid_bk) then
                if(.not.allocated(block(ise,nx,mh)%b(jb)%s(kx)%uv)) then
                  iac=1
                  call para_range(1,block(ise,nx,mh)%sizex(jb,kx),
     &                           np_env,myid_env,lsta,lend)
                  lsize=lend-lsta+1
                  allocate(block(ise,nx,mh)%b(jb)%s(kx)
     &                     %uv(lsta:lend,
     &                         block(ise,nx,mh)%ista0(jb,1):
     &                         block(ise,nx,mh)%iend0(jb,1)))
                  mem_uv=mem_uv+8*size(block(ise,nx,mh)%b(jb)%s(kx)%uv)
                end if
              end if
              call mpi_bcast(iac,1,mpi_integer,kid0(ib),newcomm_bk,ierr)

              if(iac.ne.0) then
                if(myid_bk.eq.block(ise,nx,mh)%kid(jb)) then
                  call para_range(1,block(ise,nx,mh)%sizex(jb,kx),
     &                            np_env,myid_env,lsta,lend)
                  lsize=lend-lsta+1
                  call mpi_send(block(ise,nx,mh)%b(jb)%s(kx)
     &                          %uv(:,block(ise,nx,mh)%ista0(jb,1):
     &                                block(ise,nx,mh)%iend0(jb,1)),
     &                          lsize*block(ise,nx,mh)%isize0(jb,1),
     &                          mpi_double_precision,
     &                          kid0(ib),
     &                          ib*1000+jb,
     &                          newcomm_bk,ierr)
                elseif(myid_bk.eq.kid0(ib)) then
                  call mpi_recv(block(ise,nx,mh)%b(jb)%s(kx)
     &                          %uv(:,block(ise,nx,mh)%ista0(jb,1):
     &                                block(ise,nx,mh)%iend0(jb,1)),
     &                          lsize*block(ise,nx,mh)%isize0(jb,1),
     &                          mpi_double_precision,
     &                          block(ise,nx,mh)%kid(jb),
     &                          ib*1000+jb,
     &                          newcomm_bk,mpist,ierr)
                end if
              end if
            enddo
          enddo
        enddo
      end if
      deallocate(mpist)

      return
      end
