      subroutine mv_4(id,vin,vout,bp,pp,cf)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: id,ib,jb,i0,i1,k0,k1,lsta,lend,lsize,ih
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  cf,zz
      type(avec) :: vin(isbk0:iebk0),vout(nbk)
      type(bvec) :: tp(2)
      type(bop) :: bp(2),pp(4)

      ih=1

      do ib=isbk0,iebk0
        jb=bp(1)%jbk(ib)
        if(jb.eq.0) cycle
        do i0=1,nfrx(1)
          do k0=1,nfrx(2)
            i1=bp(1)%io(i0)
            k1=bp(2)%io(k0)
            if(i1*k1.eq.0) cycle

            if(bk(ib,1,ih)%sizex(i0)*bk(ib,2,ih)%sizex(k0).ne.0.and.
     &         bk(jb,1,ih)%sizex(i1)*bk(jb,2,ih)%sizex(k1).ne.0) then

              allocate(tp(1)%b(bk(jb,1,ih)%ivs(i1):bk(jb,1,ih)%ive(i1),
     &                         bk(ib,2,ih)%ivs(k0):bk(ib,2,ih)%ive(k0)))

              call vclear(vout(jb),nv(i1,k1,jb),i1,k1,
     &                    bk(jb,1,ih)%ivs(i1),bk(jb,1,ih)%ive(i1),
     &                    bk(jb,2,ih)%sizex(k1))

              call para_ranges(1,bk(ib,1,ih)%sizex(i0),np_vec,myid_vec,
     &                         lsta,lend,lsize)

              if(bk(ib,2,ih)%isz(k0)*bk(jb,1,ih)%isz(i1)
     &             *lsize.ne.0) then
c#ifdef cmplx_v
c                zz=conjg(bp(1)%fs(i0)*bp(1)%vo(i0))
c#else
                zz=bp(1)%fs(i0)*bp(1)%vo(i0)
c#endif
                call XGEMM(chmm(1),chmm(1),
     &                 bk(jb,1,ih)%isz(i1),
     &                 bk(ib,2,ih)%isz(k0),
     &                 lsize,
     &                 zz,
     &                 pp(1)%bt(bk(ib,1,ih)%ap(ad(i0,k0))%nse(1))%op,
     &                 bk(jb,1,ih)%isz(i1),
     &                 vin(ib)%ap(ad(i0,k0))%b(:,bk(ib,2,ih)%ivs(k0)),
     &                 lsize,
     &                 zero,
     &                 tp(1)%b,
     &                 bk(jb,1,ih)%isz(i1))
              else
!$OMP PARALLEL WORKSHARE
                tp(1)%b=zero
!$OMP END PARALLEL WORKSHARE
              end if

              call para_ranges(1,bk(jb,2,ih)%sizex(k1),np_vec,myid_vec,
     &                         lsta,lend,lsize)

              if(bk(ib,2,ih)%isz(k0)*bk(jb,1,ih)%isz(i1)
     &               *lsize.ne.0) then
c#ifdef cmplx_v
c                zz=conjg(bp(2)%fs(k0)*bp(2)%vo(k0)*cf)
c#else
                zz=bp(2)%fs(k0)*bp(2)%vo(k0)*cf
c#endif

                call XGEMM(chmm(1),chmm(2),
     &                 bk(jb,1,ih)%isz(i1),
     &                 lsize,
     &                 bk(ib,2,ih)%isz(k0),
     &                 zz,
     &                 tp(1)%b,
     &                 bk(jb,1,ih)%isz(i1),
     &                 pp(2)%bt(bk(ib,1,ih)%ap(ad(i0,k0))%nse(2))%op,
     &                 lsize,
     &                 one,
     &                 vout(jb)%ap(ad(i1,k1))%b(:,lsta),
     &                 bk(jb,1,ih)%isz(i1))
              end if

              deallocate(tp(1)%b)

            end if
          enddo
        enddo
      enddo

      if(id.eq.0) return

      do ib=isbk0,iebk0
        jb=bp(2)%jbk(ib)
        if(jb.eq.0) cycle
        do i1=1,nfrx(1)
          do k1=1,nfrx(2)
            i0=bp(1)%io(i1)
            k0=bp(2)%io(k1)
            if(i0*k0.eq.0) cycle

            if(bk(ib,1,ih)%sizex(i0)*bk(ib,2,ih)%sizex(k0).ne.0.and.
     &         bk(jb,1,ih)%sizex(i1)*bk(jb,2,ih)%sizex(k1).ne.0) then

              allocate(tp(1)%b(bk(jb,1,ih)%ivs(i1):bk(jb,1,ih)%ive(i1),
     &                         bk(ib,2,ih)%ivs(k0):bk(ib,2,ih)%ive(k0)))

              call vclear(vout(jb),nv(i1,k1,jb),i1,k1,
     &                    bk(jb,1,ih)%ivs(i1),bk(jb,1,ih)%ive(i1),
     &                    bk(jb,2,ih)%sizex(k1))

              call para_ranges(1,bk(ib,1,ih)%sizex(i0),np_vec,myid_vec,
     &                         lsta,lend,lsize)

              if(bk(ib,2,ih)%isz(k0)*bk(jb,1,ih)%isz(i1)
     &               *lsize.ne.0) then
#ifdef cmplx_v
                zz=conjg(bp(1)%fs(i1)*bp(1)%vo(i1))
#else
                zz=bp(1)%fs(i1)*bp(1)%vo(i1)
#endif
                call XGEMM(chmm(2),chmm(1),
     &                 bk(jb,1,ih)%isz(i1),
     &                 bk(ib,2,ih)%isz(k0),
     &                 lsize,
     &                 zz,
     &                 pp(3)%bt(bk(jb,1,ih)%ap(ad(i1,k1))%nse(1))%op,
     &                 lsize,
     &                 vin(ib)%ap(ad(i0,k0))%b(:,bk(ib,2,ih)%ivs(k0)),
     &                 lsize,
     &                 zero,
     &                 tp(1)%b,
     &                 bk(jb,1,ih)%isz(i1))
              else
!$OMP PARALLEL WORKSHARE
                tp(1)%b=zero
!$OMP END PARALLEL WORKSHARE
              end if

              call para_ranges(1,bk(jb,2,ih)%sizex(k1),np_vec,myid_vec,
     &                         lsta,lend,lsize)

              if(bk(ib,2,ih)%isz(k0)*bk(jb,1,ih)%isz(i1)
     &               *lsize.ne.0) then
#ifdef cmplx_v
                zz=conjg(bp(2)%fs(k1)*bp(2)%vo(k1)*cf)
#else
                zz=bp(2)%fs(k1)*bp(2)%vo(k1)*cf
#endif
                call XGEMM(chmm(1),chmm(1),
     &                 bk(jb,1,ih)%isz(i1),
     &                 lsize,
     &                 bk(ib,2,ih)%isz(k0),
     &                 zz,
     &                 tp(1)%b,
     &                 bk(jb,1,ih)%isz(i1),
     &                 pp(4)%bt(bk(jb,1,ih)%ap(ad(i1,k1))%nse(2))%op,
     &                 bk(ib,2,ih)%isz(k0),
     &                 one,
     &                 vout(jb)%ap(ad(i1,k1))%b(:,lsta:lend),
     &                 bk(jb,1,ih)%isz(i1))
              end if

              deallocate(tp(1)%b)

            end if
          enddo
        enddo
      enddo

      return
      end
