      subroutine mv_apt(vin,vout,cf)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ib,i0,k0,lsta,lend,ix1,ix2,ih
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  cf,fg
      real(8),allocatable :: fmagza(:,:)
      type(avec) :: vin(isbk0:iebk0),vout(nbk)

      if(.not.allocated(fmag)) return

      ih=1

      if(id_space.eq.0) then
! --- X-DIRECTION
        fg=-cf*fmag(1,nse(1)+1)*cmag(1)
        do i0=1,nfrx(1)-1
          do k0=1,nfrx(2)
            call para_range(1,bk(1,1,ih)%sizex(i0+1),np_vec,myid_vec,
     &                      lsta,lend)
            do ix2=bk(1,2,ih)%ivs(k0),bk(1,2,ih)%ive(k0)
              do ix1=max(bk(1,1,ih)%ivs(i0+1),lsta),
     &               min(bk(1,1,ih)%ive(i0+1),lend)
                vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &            =vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &               +fg*vin(1)%ap(ad(i0+1,k0))%b(ix1,ix2)
              enddo
            enddo
          enddo
        enddo

        do i0=2,nfrx(1)
          do k0=1,nfrx(2)
            call para_range(1,bk(1,1,ih)%sizex(i0-1),np_vec,myid_vec,
     &                      lsta,lend)
            do ix2=bk(1,2,ih)%ivs(k0),bk(1,2,ih)%ive(k0)
              do ix1=max(bk(1,1,ih)%ivs(i0-1),lsta),
     &               min(bk(1,1,ih)%ive(i0-1),lend)
                vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &            =vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &               +fg*vin(1)%ap(ad(i0-1,k0))%b(ix1,ix2)
              enddo
            enddo
          enddo
        enddo

        fg=-cf*fmag(1,nse(1)+2)*cmag(1)
        do i0=1,nfrx(1)
          do k0=1,nfrx(2)-1
            call para_range(1,bk(1,1,ih)%sizex(i0),np_vec,myid_vec,
     &                      lsta,lend)
            do ix2=bk(1,2,ih)%ivs(k0+1),bk(1,2,ih)%ive(k0+1)
              do ix1=max(bk(1,1,ih)%ivs(i0),lsta),
     &               min(bk(1,1,ih)%ive(i0),lend)
                vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &            =vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &               +fg*vin(1)%ap(ad(i0,k0+1))%b(ix1,ix2)
              enddo
            enddo
          enddo
        enddo

        do i0=1,nfrx(1)
          do k0=2,nfrx(2)
            call para_range(1,bk(1,1,ih)%sizex(i0),np_vec,myid_vec,
     &                      lsta,lend)
            do ix2=bk(1,2,ih)%ivs(k0-1),bk(1,2,ih)%ive(k0-1)
              do ix1=max(bk(1,1,ih)%ivs(i0),lsta),
     &               min(bk(1,1,ih)%ive(i0),lend)
                vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &            =vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &               +fg*vin(1)%ap(ad(i0,k0-1))%b(ix1,ix2)
              enddo
            enddo
          enddo
        enddo

! --- Y-DIRECTION
#ifdef cmplx_v
        fg=cf*cmplx(0.d0,-fmag(2,nse(1)+1)*cmag(2),kind=8)
        do i0=1,nfrx(1)-1
          do k0=1,nfrx(2)
            call para_range(1,bk(1,1,ih)%sizex(i0+1),np_vec,myid_vec,
     &                      lsta,lend)
            do ix2=bk(1,2,ih)%ivs(k0),bk(1,2,ih)%ive(k0)
              do ix1=max(bk(1,1,ih)%ivs(i0+1),lsta),
     &               min(bk(1,1,ih)%ive(i0+1),lend)
                vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &            =vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &               +fg*vin(1)%ap(ad(i0+1,k0))%b(ix1,ix2)
              enddo
            enddo
          enddo
        enddo

        do i0=2,nfrx(1)
          do k0=1,nfrx(2)
            call para_range(1,bk(1,1,ih)%sizex(i0-1),np_vec,myid_vec,
     &                      lsta,lend)
            do ix2=bk(1,2,ih)%ivs(k0),bk(1,2,ih)%ive(k0)
              do ix1=max(bk(1,1,ih)%ivs(i0-1),lsta),
     &               min(bk(1,1,ih)%ive(i0-1),lend)
                vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &            =vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &               -fg*vin(1)%ap(ad(i0-1,k0))%b(ix1,ix2)
              enddo
            enddo
          enddo
        enddo

        fg=cf*cmplx(0.d0,-fmag(2,nse(1)+2)*cmag(2),kind=8)
        do i0=1,nfrx(1)
          do k0=1,nfrx(2)-1
            call para_range(1,bk(1,1,ih)%sizex(i0),np_vec,myid_vec,
     &                      lsta,lend)
            do ix2=bk(1,2,ih)%ivs(k0+1),bk(1,2,ih)%ive(k0+1)
              do ix1=max(bk(1,1,ih)%ivs(i0),lsta),
     &               min(bk(1,1,ih)%ive(i0),lend)
                vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &            =vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &               +fg*vin(1)%ap(ad(i0,k0+1))%b(ix1,ix2)
              enddo
            enddo
          enddo
        enddo

        do i0=1,nfrx(1)
          do k0=2,nfrx(2)
            call para_range(1,bk(1,1,ih)%sizex(i0),np_vec,myid_vec,
     &                      lsta,lend)
            do ix2=bk(1,2,ih)%ivs(k0-1),bk(1,2,ih)%ive(k0-1)
              do ix1=max(bk(1,1,ih)%ivs(i0),lsta),
     &               min(bk(1,1,ih)%ive(i0),lend)
                vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &            =vout(1)%ap(ad(i0,k0))%b(ix1,ix2)
     &               -fg*vin(1)%ap(ad(i0,k0-1))%b(ix1,ix2)
              enddo
            enddo
          enddo
        enddo
#endif
      end if

! --- Z-DIRECTION
      allocate(fmagza(nfrx(1),nfrx(2)))
      if(nas.eq.1.and.nae.eq.1) then !z-direction
!$OMP PARALLEL DO
        do i0=1,nfrx(1)
          do k0=1,nfrx(2)
            fmagza(i0,k0)=(fmag(3,nse(1)+1)*dble(iud(i0,1)-iud(i0,2))
     &                    +fmag(3,nse(1)+2)*dble(iud(k0,1)-iud(k0,2)))
     &                    *cmag(3)
          enddo
        enddo
      elseif(nas.eq.1.and.nae.eq.0) then
!$OMP PARALLEL DO
        do i0=1,nfrx(1)
          fmagza(i0,1)=fmag(3,nse(1)+1)*dble(iud(i0,1)-iud(i0,2))
     &                *cmag(3)
        enddo
      elseif(nas.eq.0.and.nae.eq.1) then
!$OMP PARALLEL DO
        do k0=1,nfrx(2)
          fmagza(1,k0)=fmag(3,nse(1)+1)*dble(iud(k0,1)-iud(k0,2))
     &                *cmag(3)
        enddo
      end if

!$OMP PARALLEL DO PRIVATE(lsta,lend)
      do ib=isbk0,iebk0
        do i0=1,nfrx(1)
          do k0=1,nfrx(2)
            call para_range(1,bk(ib,1,ih)%sizex(i0),np_vec,myid_vec,
     &                      lsta,lend)

            do ix2=bk(ib,2,ih)%ivs(k0),bk(ib,2,ih)%ive(k0)
              do ix1=max(bk(ib,1,ih)%ivs(i0),lsta),
     &               min(bk(ib,1,ih)%ive(i0),lend)
                vout(ib)%ap(ad(i0,k0))%b(ix1,ix2)
     &            =vout(ib)%ap(ad(i0,k0))%b(ix1,ix2)
     &               -cf*fmagza(i0,k0)
     &                 *vin(ib)%ap(ad(i0,k0))%b(ix1,ix2)
              enddo
            enddo

          enddo
        enddo
      enddo
      deallocate(fmagza)

      return
      end
