      subroutine normalize(v0)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ib,i,k,ih
      real(8) :: ax
      type(avec) :: v0(isbk1:iebk1)

      ih=1

      call lz_norm(v0,ax)

      if(ax.lt.1.d-12) then
        call irandvec(v0)
        call lz_norm(v0,ax)
      end if

      if(abs(ax-1.d0).gt.1.d-12) then
        ax=1.d0/ax
        do ib=isbk1,iebk1
          do k=1,nfrx(2)
            do i=1,nfrx(1)
              if((bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &          *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1).ne.0) then

                call XSCAL((bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &                    *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1),
     &                     ax,v0(ib)%ap(ad(i,k))%b,1)

              end if
            enddo
          enddo
        enddo
      end if

      return
      end
