      subroutine parac_block(istab,iendb,istac,iendc,npx,myidx,
     &                       newcommx)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: istab,iendb,ib,i,k,isbkx,iebkx,ip,
     &           istac,iendc,npx,myidx,newcommx,ih
      integer,allocatable :: isbkt(:),iebkt(:)
      real(8) :: tcst0
      real(8),allocatable :: cst(:),tcst(:)
      integer,parameter :: nf=1

      ih=1

      call para_range(istab,iendb,npx,myidx,isbkx,iebkx)
      istac=isbkx; iendc=iebkx
      if(npx.eq.1.or.(iendb-istab+1).le.npx) return

      allocate(cst(istab:iendb))
!$OMP PARALLEL DO
      do ib=istab,iendb
        cst(ib)=0.d0
        do k=1,nfrx(2)
          do i=1,nfrx(1)
            cst(ib)=cst(ib)
     &              +bk(ib,1,ih)%sizex(i)
     &              *bk(ib,2,ih)%sizex(k)
          enddo
        enddo
      enddo

      if(myidx.eq.0) then
        istac=istab
      elseif(myidx+1.eq.npx) then
        istac=iendb
      else
        istac=maxloc(cst(isbkx:iebkx),1)+isbkx-1
      end if

      allocate(isbkt(npx),iebkt(npx))
      call mpi_allgather(istac,1,MPI_INTEGER,isbkt,1,MPI_INTEGER,
     &                   newcommx,ierr)
      iebkt=isbkt

      allocate(tcst(npx))
      tcst0=cst(istac)
      call mpi_allgather(tcst0,1,MPI_REAL8,tcst,1,MPI_REAL8,
     &                   newcommx,ierr)

!$OMP PARALLEL DO
      do ip=1,npx-1,2
        do while(iebkt(ip)+1.lt.isbkt(ip+1))
          if(tcst(ip).le.tcst(ip+1)) then
            iebkt(ip)=iebkt(ip)+1
            tcst(ip)=tcst(ip)+cst(iebkt(ip))
          else
            isbkt(ip+1)=isbkt(ip+1)-1
            tcst(ip+1)=tcst(ip+1)+cst(isbkt(ip+1))
          end if
        enddo
      enddo
!$OMP PARALLEL DO
      do ip=2,npx-1,2
        do while(iebkt(ip)+1.lt.isbkt(ip+1))
          if(tcst(ip).le.tcst(ip+1)) then
            iebkt(ip)=iebkt(ip)+1
            tcst(ip)=tcst(ip)+cst(iebkt(ip))
          else
            isbkt(ip+1)=isbkt(ip+1)-1
            tcst(ip+1)=tcst(ip+1)+cst(isbkt(ip+1))
          end if
        enddo
      enddo

      istac=isbkt(myidx+1)
      iendc=iebkt(myidx+1)

      deallocate(cst,isbkt,iebkt,tcst)

      return
      end
