      subroutine save_block(tb,ise)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      type(blocks) :: tb
      integer :: ise,ib,ista,iend,i,k,it,mem0,mem1,ih

      ih=1

      if(allocated(tb%b)) then
        mem0=0; mem1=0
!$OMP PARALLEL DO REDUCTION(+:mem0,mem1)
        do ib=1,tb%nbk
          do i=1,nfr
            if(allocated(tb%b(ib)%s(i)%uv)) then
              mem0=mem0+size(tb%b(ib)%s(i)%uv)
            end if
          enddo
          if(allocated(tb%b(ib)%hm)) then
            mem1=mem1+size(tb%b(ib)%hm)
          end if
        enddo
        mem_uv=mem_uv-mem0
        mem_hm=mem_hm-(1+2*id_hop)*mem1
      end if

      if(allocated(tb%nud)) deallocate(tb%nud)
      if(allocated(tb%b2b)) deallocate(tb%b2b)
      if(allocated(tb%size)) deallocate(tb%size)
      if(allocated(tb%size0)) deallocate(tb%size0)
      if(allocated(tb%sizex)) deallocate(tb%sizex)
      if(allocated(tb%stax)) deallocate(tb%stax)
      if(allocated(tb%nse)) deallocate(tb%nse)
      if(allocated(tb%b)) deallocate(tb%b)
      if(allocated(tb%kid)) deallocate(tb%kid)

      if(allocated(tb%ista0)) deallocate(tb%ista0)
      if(allocated(tb%iend0)) deallocate(tb%iend0)
      if(allocated(tb%isize0))
     &  deallocate(tb%isize0)

      if(allocated(tb%ista)) deallocate(tb%ista)
      if(allocated(tb%iend)) deallocate(tb%iend)
      if(allocated(tb%isize))
     &  deallocate(tb%isize)

      if(allocated(tb%chbk)) deallocate(tb%chbk)
      if(allocated(tb%ichbk)) deallocate(tb%ichbk)

      allocate(tb%nud(nbk,2),
     &         tb%b2b(nbk,-1:1,nop),
     &         tb%size(nbk),
     &         tb%size0(nbk),
     &         tb%sizex(nbk,nfr),
     &         tb%stax(nbk,nfr),
     &         tb%b(nbk),
     &         tb%nse(nbk,nfr),
     &         tb%kid(nbk),
     &         tb%ista0(nbk,2),
     &         tb%iend0(nbk,2),
     &         tb%isize0(nbk,2),
     &         tb%ista(nbk,2),
     &         tb%iend(nbk,2),
     &         tb%isize(nbk,2),
     &         tb%chbk(nbk),
     &         tb%ichbk(nbk))

      tb%nbk=nbk
      tb%ndmx=sum(bk(1:nbk,ise,ih)%size)
      tb%isbk=isbk0
      tb%iebk=iebk0
      tb%isbk1=isbk1
      tb%iebk1=iebk1
      tb%isbk2=isbk2
      tb%iebk2=iebk2
      tb%isbk3=isbk3
      tb%iebk3=iebk3
      tb%isbk4=isbk4
      tb%iebk4=iebk4

!$OMP PARALLEL DO PRIVATE(ista,iend)
      do ib=1,nbk
        tb%size0(ib)=bk(ib,ise,ih)%size

        tb%kid(ib)=kid0(ib)

        call para_range(1,bk(ib,ise,ih)%size,np_sys,myid_sys,ista,iend)
        tb%ista0(ib,1)=ista
        tb%iend0(ib,1)=iend
        tb%isize0(ib,1)=iend-ista+1
        call para_range(1,bk(ib,ise,ih)%size,np_env,myid_env,ista,iend)
        tb%ista0(ib,2)=ista
        tb%iend0(ib,2)=iend
        tb%isize0(ib,2)=iend-ista+1

        do it=1,nop
          tb%b2b(ib,-1,it)=bk(ib,ise,ih)%ibs(-1,it)
        enddo
        do it=1,nop
          tb%b2b(ib,0,it)=ib
        enddo
        do it=1,nop
          tb%b2b(ib,1,it)=bk(ib,ise,ih)%ibs(1,it)
        enddo

        tb%nud(ib,1)=bk(ib,ise,ih)%up
        tb%nud(ib,2)=bk(ib,ise,ih)%dw

        if(ise.eq.1) then
          do i=1,nfrx(1)
            do k=1,nfrx(2)
              tb%nse(ib,i)=bk(ib,1,ih)%ap(ad(i,k))%nse(ise)
              if(bk(ib,1,ih)%ap(ad(i,k))%nse(ise).ne.0) exit
            enddo
          enddo
        elseif(ise.eq.2) then
          do k=1,nfrx(2)
            do i=1,nfrx(1)
              tb%nse(ib,k)=bk(ib,1,ih)%ap(ad(i,k))%nse(ise)
              if(bk(ib,1,ih)%ap(ad(i,k))%nse(ise).ne.0) exit
            enddo
          enddo
        end if

        do i=1,nfr
          tb%sizex(ib,i)=bk(ib,ise,ih)%sizex(i)
          tb%stax(ib,i)=bk(ib,ise,ih)%stax(i)
        enddo

        tb%chbk(ib)=ib
        tb%ichbk(ib)=ib

      enddo

      return
      end
