      subroutine single_opx(ms1,ks1,io,vo,b)
      use mod_dmrg
      implicit none
      include 'mpif.h'
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  vo(nfr),b,a
      integer :: ms1,ks1(ms1),io(nfr),ix,ix1,ix2
#ifdef cmplx_v
      complex(8),allocatable ::
#else
      real(8),allocatable ::
#endif
     &  ops(:,:)

      allocate(ops(nfr,nfr))

      call single_op(ms1,ks1,ops)

c#ifdef cmplx_v
c      if(sum(ks1).lt.0) then
c        a=conjg(b)
c      else
c        a=b
c      end if
c#else
      a=b
c#endif

!$OMP PARALLEL DO PRIVATE(ix1,ix2)
      do ix=1,nfr*nfr
        ix1=mod(ix-1,nfr)+1
        ix2=(ix-1)/nfr+1
        if(abs(ops(ix1,ix2)).gt.abs(zero)) then
          vo(ix1)=vo(ix1)+a*ops(ix1,ix2)
          io(ix1)=ix2
        end if
      enddo

      deallocate(ops)

      return
      end
