      subroutine update_basis(ise,nx,mhx,istrg,ietrg,id1,id_trah)
      use mod_dmrg_input
      use mod_dmrg_mpi
      implicit none
      include 'mpif.h'
      integer :: ise,nx,mhx,istrg,ietrg,id1,id_trah
#ifdef timer
      real(8) :: timed,time_res0,time_res
#endif
      call wf_weight(istrg,ietrg)
      call digdm(ise,nx,mhx,istrg,ietrg)
#ifdef timer
      timed=mpi_wtime()
#endif
      if(id_trah.eq.1) then
        call trans_operators(ise,nx,mhx)
        if(id1.eq.1) then
          call trans_operators_hop(ise,nx,mhx)
        end if
      end if

#ifdef timer
      time_res0=mpi_wtime()-timed
      call mpi_allreduce(time_res0,time_res,1,MPI_REAL8,mpi_max,
     &                   newcomm_dmrg,ierr)
c      if(myid_dmrg.eq.key_rank) then
c        write(iso,'(2x,a,f10.4,a)')
c     &    '(transformation) :',time_res,' [s]'
c      end if
#endif

      return
      end
